/*
 *	dataanaly.h
 */

/*	Copyright (C) 1999, 2000 Sebastian Biallas (sb@web-productions.de)
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License version 2 as
 *	published by the Free Software Foundation.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef dataanaly_h
#define dataanaly_h

#include "global.h"
#include "analy.h"


typedef enum {op_read, op_write, op_offset} OP;

typedef enum {
	dtunknown,
	dtcode,
	dtint,
	dtfloat,
	dtarray
} taddrtypetype;

typedef enum {
	dstcunknown,
	dstlabel,
	dstfunction
} taddrcodesubtype;

typedef enum {
	dstiunknown,
	dstibyte,
	dstiword,
	dstidword,
	dstipword,
	dstiqword
} taddrintsubtype;

typedef enum {
	dstfunknown
} taddrfloatsubtype;

typedef enum {
	dstaunknown,
	dstabyte,
	dstaword,
	dstadword,
	dstapword,
	dstaqword,
	dststring,
	dstunistring
} taddrarraysubtype;

struct taddrtype {
	taddrtypetype	type;
	union {
		byte				subtype;
		taddrcodesubtype	codesubtype;
		taddrintsubtype	intsubtype;
		taddrfloatsubtype	floatsubtype;
		taddrarraysubtype	arraysubtype;
	};
	union {
		dword  length;
		// ...?
	};
};

class analyser;

class dataanalyser: public object	{
public:
	analyser		*analy;
						dataanalyser() {};
	virtual				~dataanalyser() {};
			void			init(analyser *Analy);
			int			load(htstream *f);
	virtual	void  		done();

			void			access(ADDR Addr, OP op, int size);
			void			setaddrtype(ADDR Addr, taddrtypetype type, int subtype, int length);
			void			setcodeaddrtype(ADDR Addr, taddrcodesubtype subtype, int length);
			void			setintaddrtype(ADDR Addr, taddrintsubtype subtype, int length);
			void			setfloataddrtype(ADDR Addr, taddrfloatsubtype subtype, int length);
			void			setarrayaddrtype(ADDR Addr, taddrarraysubtype subtype, int length);
	virtual	void			store(htstream *f);
};

#endif
