/*
 *	stddata.cc
 */

/*	Copyright (C) 1999, 2000 Sebastian Biallas (sb@web-factory.de)
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License version 2 as
 *   published by the Free Software Foundation.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <stdlib.h>
#include "stddata.h"


/****************************************************************************/
void tqueue::init()
{
	first = last = NULL;
}

int	tqueue::load(htstream *f)
{
	int Count;
	f->read(&Count, 4);
	for (int i=0; i<Count; i++) {
		void *data;
		if (!load_element(f, &data)) {
			return -1;
		}
		// FIXME: does this reverse the order?
		enqueue(data);
	}
	return 0;
}

int	tqueue::load_element(htstream *f, void **data)
{
	return 0;
}

void tqueue::done()
{
	clear();
}

void tqueue::clear()
{
	while (!empty()) {
		free_element(dequeue());
	}
}

int	tqueue::count()
{
	tqueuemember	*tmp = first;
	int			result = 0;
	while (tmp) {
		result++;
		tmp = tmp->next;
	}
	return result;
}

bool tqueue::empty()
{
	return (first==NULL);
}

void tqueue::free_element(void *data)
{
	free(data);
}

void tqueue::enqueue(void *p)
{
	tqueuemember	*tmp = (tqueuemember *) malloc(sizeof(tqueuemember));
	tmp->next = NULL;
	if (first == NULL) {
		first = last = tmp;
	} else {
		last->next = tmp;
		last = tmp;
	}
	last->data = p;
}

void *tqueue::dequeue()
{
	void	*ret = top();
	if (!empty()) {
		tqueuemember	*tmp = first;
		first = first->next;
		free(tmp);
		if (!first) last = NULL;
	}
	return ret;
}

void	tqueue::store(htstream *f)
{
	int Count = count();
	f->write(&Count, 4);
	tqueuemember	*tmp = first;
	while (tmp) {
		store_element(f, tmp->data);
		tmp = tmp->next;
	}
}

void	tqueue::store_element(htstream *f, void *data)
{
}

void *tqueue::top()
{
	return empty() ? NULL : first->data;
}

/*
 *
 */

void tstack::init()
{
	stop = NULL;
}

void tstack::done()
{
	clear();
}

bool tstack::empty()
{
	return (stop==NULL);
}

void tstack::clear()
{
	while (!empty()) pop();
}

void *tstack::top()
{
	return empty() ? NULL : stop->data;
}

void tstack::push(void *p)
{
//	tstackmember	*tmp = (tstackmember *) malloc(sizeof(tstackmember));
}

void *tstack::pop()
{
	void	*ret = top();
	if (!empty()) {
		tstackmember *tmp = stop;
		stop = stop->next;
		free(tmp);
	}
	return ret;
}

