/*
 *	htanaly.h
 */

/*	Copyright (C) 1999, 2000 Sebastian Biallas (sb@web-productions.de)
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License version 2 as
 *	published by the Free Software Foundation.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef HTANALY_H
#define HTANALY_H

#include "htobj.h"
#include "analy.h"
#include "global.h"

#define ANALY_DEFAULT_STATUS "fofs: %08lx %s %s"
#define ANALY_DEFAULT_STATUS_ARG_ORDER "o,c,u"
#define ANALY_DEFAULT_STATUS_ARG_FILEOFFSET 'o'
#define ANALY_DEFAULT_STATUS_ARG_CODEBYTES 'c'
#define ANALY_DEFAULT_STATUS_ARG_RAWUNASM 'u'

class ht_aviewer;

class analy_infoline: public ht_winstatictext {
public:
	ht_aviewer	*analy;
	char			*s;
	dword		fofs;
	ADDR			addr;
	char			*displayformat;
				analy_infoline(bounds *b, ht_aviewer *A, char *Format);
				~analy_infoline();
	virtual	char *gettext();
			void update(ADDR cursor_addr);
			bool valid();
};

/*
 *	CLASS ht_aviewer
 */

class ht_aviewer: public ht_uviewer {
public:
	int idle_count;
	analyser *analy;
	int last_active;
	analy_infoline *infoline;
	ht_aviewer(bounds *b, char *desc, htstream *file, int caps, analyser *Analy);
	virtual ~ht_aviewer();
		   void attach_infoline(analy_infoline *V);
	virtual void handlemsg(htmsg *msg);
	virtual void idle();
	virtual int  jumpstr(char *str);
};

/*
 *	CLASS hts_analy
 */

class hts_analy: public hts_sub {
public:
	analyser		*analy;
	ADDR			lowestaddress, highestaddress;
				hts_analy(htstream *file, analyser *A, ADDR Lowestaddress, ADDR Highestaddress);
	virtual		~hts_analy();
	virtual void	end_line_address(dword *ofs, int *yofs);
	virtual int 	getline(char *line, dword ofs, int yofs);
	virtual int	next_line_address(dword *ofs, int *yofs, int n);
	virtual int	prev_line_address(dword *ofs, int *yofs, int n);
	virtual void	start_line_address(dword *ofs, int *yofs);
	virtual int 	jump(ADDR tofs, ADDR *ofs, int *yofs);
};

#endif
