/* 
 *	HT Editor
 *	hthist.cc
 *
 *	Copyright (C) 1999,2000 Stefan Weyergraf (stefan@weyergraf.de)
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License version 2 as
 *	published by the Free Software Foundation.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "hthist.h"

vs_stack *vs_history;

/*
 *	CLASS vs_stack
 */

vs_stack::vs_stack()
{
	top=0;
}

vs_stack::~vs_stack()
{
}

void vs_stack::push(vstate *vs)
{
	vs_item *p=top;
	top=new vs_item;
	top->prev=p;
	top->vs=vs;
}

vstate *vs_stack::pop()
{
	if (top) {
		vs_item *t=top;
		vstate *r=top->vs;
		top=top->prev;
		delete t;
		return r;
	}
	return 0;
}

/*
 *	INIT
 */

int init_hist()
{
	vs_history=new vs_stack();
	return 1;
}

/*
 *	DONE
 */

void done_hist()
{
	delete vs_history;
}

