/* 
 *	HT Editor
 *	hthist.h
 *
 *	Copyright (C) 1999,2000 Stefan Weyergraf (stefan@weyergraf.de)
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License version 2 as
 *	published by the Free Software Foundation.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef HTHIST_H
#define HTHIST_H

#include "htobj.h"

/*
 *	STRUCT vstate
 */

struct vstate {
	ht_view *focused;		/* view to focus */
	ht_view *view;			/* view whose state has changed */
	void *data;			/* "view"s data */
};

/*
 *	CLASS vs_stack
 */

struct vs_item {
	vs_item *prev;
	vstate *vs;
};

class vs_stack {
protected:
	vs_item *top;
public:
	vs_stack();
	~vs_stack();
/* new */
	void push(vstate *vs);
	vstate *pop();
};

/*
 *	INIT
 */

int init_hist();

/*
 *	DONE
 */

void done_hist();

/*
 *	vars
 */

extern vs_stack *vs_history;

#endif /* HTHIST_H */
