/* 
 *	HT Editor
 *	htle.h
 *
 *	Copyright (C) 1999,2000 Stefan Weyergraf (stefan@weyergraf.de)
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License version 2 as
 *	published by the Free Software Foundation.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __HTLE_H__
#define __HTLE_H__

#include "htobj.h"

#include "lestruct.h"

#define DESC_LE "le"
#define DESC_LE_HEADER "le/header"
#define DESC_LE_OBJECTS "le/objects"
#define DESC_LE_PAGEMAPS "le/page map"
#define DESC_LE_IMAGE "le/image"

struct ht_le_shared_data {
	dword hdr_ofs;
	IMAGE_LE_HEADER hdr;
	ht_viewer *v_header;
	ht_viewer *v_objects;
	ht_viewer *v_pagemaps;
	ht_viewer *v_image;
	ht_le_pagemap pagemap;
};

class ht_le: public ht_xgroup {
private:
	ht_le_shared_data *le_shared;
public:
	ht_le(bounds *b, htstream *file);
	~ht_le();
};

extern viewer_int htle_int;

#endif /* __HTLE_H__ */
