/* 
 *	HT Editor
 *	htlehead.cc
 *
 *	Copyright (C) 1999,2000 Stefan Weyergraf (stefan@weyergraf.de)
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License version 2 as
 *	published by the Free Software Foundation.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "htnewexe.h"
#include "htle.h"
#include "htlehead.h"
#include "httag.h"
#include "viewers.h"

#include "lestruct.h"

/*
#define object_header_mask_count 7

mask object_header_mask[object_header_mask_count]	=
	{
	  { mt_dword, 		0x0000, "virtual size" },
	  { mt_dword, 		0x0004, "base relocation address" },
	  { mt_dword, 		0x0008, "flags" },
	  { mt_dword, 		0x000c, "page map index"	},
	  { mt_dword, 		0x0010, "page map count"	},
	  { mt_chararr, 	0x0014, "name", 4 },
	  { mt_comment,	0, 0	}
	};*/

#define EXPL_LE_MACHINES			0x00002000
#define EXPL_LE_MACHINES_STR		 "00002000"
#define EXPL_LE_OS				0x00002001
#define EXPL_LE_OS_STR			 "00002001"

int_hash le_machines[] =
{
	{ IMAGE_LE_CPU_286,	"Intel 286" },
	{ IMAGE_LE_CPU_386,	"Intel 386" },
	{ IMAGE_LE_CPU_486,	"Intel 486" },
	{ IMAGE_LE_CPU_586,	"Intel 586" },
	{ IMAGE_LE_CPU_N10,	"Intel i860(N10)" },
	{ IMAGE_LE_CPU_N11,	"Intel N11" },
	{ IMAGE_LE_CPU_R2000, "MIPS R2000"	},
	{ IMAGE_LE_CPU_R6000, "MIPS R6000"	},
	{ IMAGE_LE_CPU_R4000, "MIPS R4000"	},
	{0, 0}
};

int_hash le_os[] =
{
	{ IMAGE_LE_OS_OS2, "OS/2"},
	{ IMAGE_LE_OS_WIN, "Windows"},
	{ IMAGE_LE_OS_DOS4,	"DOS 4.x"},
	{ IMAGE_LE_OS_WIN386, "Windows 386" },
	{0, 0}
};

char *leheader[]=
{
	"magic                                            "_WORD("00000000"),
	"byte order                                       "_BYTE("00000002"),
	"word order                                       "_BYTE("00000003"),
	"level                                            "_DWORD("00000004"),
	"cpu type                                         "_WORD("00000008")" "HT_EXPL_CH EXPL_LE_MACHINES_STR,
	"os type                                          "_WORD("0000000a")" "HT_EXPL_CH EXPL_LE_OS_STR,
	"module version                                   "_DWORD("0000000c"),
	"module flags                                     "_DWORD("00000010"),
	"number of pages                                  "_DWORD("00000014"),
	"logical cs                                       "_DWORD("00000018"),
	"eip                                              "_DWORD("0000001c"),
	"logical ss                                       "_DWORD("00000020"),
	"esp                                              "_DWORD("00000024"),
	"memory page size                                 "_DWORD("00000028"),
	"last page size                                   "_DWORD("0000002c"),
	"fixup section size                               "_DWORD("00000030"),
	"fixup section checksum                           "_DWORD("00000034"),
	"loader section size                              "_DWORD("00000038"),
	"loader section checksum                          "_DWORD("0000003c"),
	"offset of object table                           "_DWORD("00000040"),
	"number of objects                                "_DWORD("00000044"),
	"offset page map                                  "_DWORD("00000048"),
	"offset iterated data                             "_DWORD("0000004c"),
	"offset of resource table                         "_DWORD("00000050"),
	"number of resource entries                       "_DWORD("00000054"),
	"offset of resident name table                    "_DWORD("00000058"),
	"offset of entry table                            "_DWORD("0000005c"),
	"offset of module directive table                 "_DWORD("00000060"),
	"number of module directives                      "_DWORD("00000064"),
	"offset of fixup page table                       "_DWORD("00000068"),
	"offset of fixup record table                     "_DWORD("0000006c"),
	"offset of import module name table               "_DWORD("00000070"),
	"number of imported modules                       "_DWORD("00000074"),
	"offset of import procedure name table            "_DWORD("00000078"),
	"offset of per-page checksum table                "_DWORD("0000007c"),
	"offset of enumerated data pages                  "_DWORD("00000080"),
	"number of preload pages                          "_DWORD("00000084"),
	"offset of non-resident names table               "_DWORD("00000088"),
	"size of non-resident names table                 "_DWORD("0000008c"),
	"non-resident name table checksum                 "_DWORD("00000090"),
	"auto data object number                          "_DWORD("00000094"),
	"offset of debug info                             "_DWORD("00000098"),
	"size of debug info                               "_DWORD("0000009c"),
	"pages in preload section                         "_DWORD("000000a0"),
	"pages in demand load section                     "_DWORD("000000a4"),
	"size of heap (16-bit)                            "_DWORD("000000a8"),
	"reserved (12 bytes)                              "_BYTE("000000ac")" "_BYTE("000000ad")" "_BYTE("000000ae")" "_BYTE("000000af"),
	"                                                 "_BYTE("000000b0")" "_BYTE("000000b1")" "_BYTE("000000b2")" "_BYTE("000000b3"),
	"                                                 "_BYTE("000000b4")" "_BYTE("000000b5")" "_BYTE("000000b6")" "_BYTE("000000b7"),
	"--- VxD only ---",
	"offset of win-resource data                      "_DWORD("000000b8"),
	"size of win-resource data                        "_DWORD("000000bc"),
	"device id                                        "_WORD("000000c0"),
	"ddk version                                      "_WORD("000000c2"),
	0
};

int htleheader_detect(htstream *file)
{
	return 1;
}

ht_view *htleheader_init(bounds *b, htstream *file, ht_group *group)
{
	ht_group *le_group=group;
	while (strcmp(le_group->desc, DESC_LE)) le_group=le_group->group;
	ht_le_shared_data *le_shared=(ht_le_shared_data *)((ht_le*)le_group)->shared_data;

	int h=le_shared->hdr_ofs;
	ht_uviewer *v=new ht_uviewer(b, DESC_LE_HEADER, file, htvc_edit);
	hts_mask *m=new hts_mask(file, h);
	register_expl(EXPL_LE_MACHINES, le_machines);
	register_expl(EXPL_LE_OS, le_os);
	char info[128];
	sprintf(info, "* LE header at offset %08lx", le_shared->hdr_ofs);
	m->add_mask(info);
	m->add_mask_table(leheader);
	v->insertsub(m);

	le_shared->v_header=v;
	return v;
}

viewer_int htleheader_int = {
	htleheader_detect,
	htleheader_init
};
