/* 
 *	HT Editor
 *	htleobj.cc
 *
 *	Copyright (C) 1999,2000 Stefan Weyergraf (stefan@weyergraf.de)
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License version 2 as
 *	published by the Free Software Foundation.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "htapp.h"
#include "htnewexe.h"
#include "htle.h"
#include "htleobj.h"
#include "httag.h"
#include "htstring.h"
#include "viewers.h"

#include "lestruct.h"

char *leobj[]=
{
	"virtual size                                     "_DWORD("00000000"),
	"relocation base address                          "_DWORD("00000004"),
	"flags                                            "_DWORD("00000008"),
	"page map index                                   "_DWORD("0000000c"),
	"page map count                                   "_DWORD("00000010"),
	"name                                             "_CHAR("00000014")""_CHAR("00000015")""_CHAR("00000016")""_CHAR("00000017"),
	0
};

int htleobjects_detect(htstream *file)
{
	return 1;
}

ht_view *htleobjects_init(bounds *b, htstream *file, ht_group *group)
{
	ht_group *le_group=group;
	while (strcmp(le_group->desc, DESC_LE)) le_group=le_group->group;
	ht_le_shared_data *le_shared=(ht_le_shared_data *)((ht_le*)le_group)->shared_data;

	int h=le_shared->hdr_ofs;
	ht_uviewer *v=new ht_uviewer(b, DESC_LE_OBJECTS, file, htvc_edit);
	hts_mask *m=new hts_mask(file, h+le_shared->hdr.objtab);

	char t[64];
	sprintf(t, "* LE object headers at offset %08lx", h+le_shared->hdr.objtab);
	m->add_mask(t);
	for (dword i=0; i<le_shared->hdr.objcnt; i++) {
		int j=0;
		char n[5];
		file->seek(h+le_shared->hdr.objtab+i*24+20);
		file->read(&n, 4);
		n[4]=0;
		sprintf(t, "--- object %ld: %s ---", i, (char*)&n);
		m->add_mask(t);
		while (leobj[j]) {
			char *s=strdup(leobj[j]);
			char *e=s;
			while ((e=findtag(e))) {
				int f=tag_get_offset(e);
				f+=i*24;
				tag_set_offset(e, f);
				e++;
			}
			m->add_mask(s);
			delete s;
			j++;
		}
	}

	v->insertsub(m);

	le_shared->v_objects=v;
	return v;
}

viewer_int htleobjects_int = {
	htleobjects_detect,
	htleobjects_init
};

