/* 
 *	HT Editor
 *	htlepage.cc
 *
 *	Copyright (C) 1999,2000 Stefan Weyergraf (stefan@weyergraf.de)
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License version 2 as
 *	published by the Free Software Foundation.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "htapp.h"
#include "htnewexe.h"
#include "htle.h"
#include "htlepage.h"
#include "httag.h"
#include "htstring.h"
#include "viewers.h"

#include "lestruct.h"

#include <stdlib.h>

char *lepagemap[]=
{
	"page high                                        "_WORD("00000000"),
	"page low                                         "_BYTE("00000002"),
	"flags                                            "_BYTE("00000003"),
	0
};

int htlepagemaps_detect(htstream *file)
{
	return 1;
}

ht_view *htlepagemaps_init(bounds *b, htstream *file, ht_group *group)
{
	ht_group *le_group=group;
	while (strcmp(le_group->desc, DESC_LE)) le_group=le_group->group;
	ht_le_shared_data *le_shared=(ht_le_shared_data *)((ht_le*)le_group)->shared_data;

	int h=le_shared->hdr_ofs;
	ht_uviewer *v=new ht_uviewer(b, DESC_LE_PAGEMAPS, file, htvc_edit);
	hts_mask *m=new hts_mask(file, h+le_shared->hdr.pagemap);

	char t[64];
	sprintf(t, "* LE page maps at offset %08lx", h+le_shared->hdr.pagemap);
	m->add_mask(t);

	le_shared->pagemap.pagesize=le_shared->hdr.pagesize;
	le_shared->pagemap.count=le_shared->hdr.pagecnt;
	le_shared->pagemap.pagemap=(dword*)malloc(le_shared->pagemap.count*4);
	for (dword i=0; i<le_shared->hdr.pagecnt; i++) {
		int j=0;
		IMAGE_LE_PAGE_MAP_ENTRY e;
		file->seek(h+le_shared->hdr.pagemap+i*4);
		file->read(&e, sizeof e);
		dword eofs=(e.high+e.low-1)*le_shared->hdr.pagesize+le_shared->hdr.datapage;
		le_shared->pagemap.pagemap[i]=eofs;
		sprintf(t, "--- page %ld at %08lx ---", i, eofs);
		m->add_mask(t);
		while (lepagemap[j]) {
			char *s=strdup(lepagemap[j]);
			char *e=s;
			while ((e=findtag(e))) {
				int f=tag_get_offset(e);
				f+=i*4;
				tag_set_offset(e, f);
				e++;
			}
			m->add_mask(s);
			delete s;
			j++;
		}
	}

	v->insertsub(m);

	le_shared->v_pagemaps=v;
	return v;
}

viewer_int htlepagemaps_int = {
	htlepagemaps_detect,
	htlepagemaps_init
};

