/* 
 *	HT Editor
 *	htmz.cc
 *
 *	Copyright (C) 1999,2000 Stefan Weyergraf (stefan@weyergraf.de)
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License version 2 as
 *	published by the Free Software Foundation.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "htmz.h"
#include "htmzhead.h"
#include "htmzrel.h"
#include "htmzimg.h"
#include "htstream.h"

int htmz_detect(htstream *file)
{
	word magic;
	file->seek(0);
	file->read(&magic, 2);
	return (magic==IMAGE_MZ_MAGIC);
}

ht_view *htmz_init(bounds *b, htstream *file, ht_group *group)
{
	ht_xgroup *g=new ht_mz(b, file);
	insert_int(g, file, &htmzheader_int);
	insert_int(g, file, &htmzrel_int);
	insert_int(g, file, &htmzimage_int);
	return g;
}

viewer_int htmz_int = {
	htmz_detect,
	htmz_init
};

ht_mz::ht_mz(bounds *b, htstream *file)
: ht_xgroup(b, hto_selectable | hto_browsable, DESC_MZ)
{
	mz_shared=new ht_mz_shared_data;
	file->seek(0);
	file->read(&mz_shared->header, sizeof mz_shared->header);
	shared_data=mz_shared;
}

ht_mz::~ht_mz()
{
}

