/* 
 *	HT Editor
 *	htmzimg.cc
 *
 *	Copyright (C) 1999,2000 Stefan Weyergraf (stefan@weyergraf.de)
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License version 2 as
 *	published by the Free Software Foundation.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "htmz.h"
#include "htmzimg.h"
#include "htpal.h"
#include "viewers.h"

int htmzimage_detect(htstream *file)
{
	return 0;
}

ht_view *htmzimage_init(bounds *b, htstream *file, ht_group *group)
{
	ht_group *mz_group=group;
	while (strcmp(mz_group->desc, DESC_MZ)) mz_group=mz_group->group;
	ht_mz_shared_data *mz_shared=(ht_mz_shared_data *)((ht_mz*)mz_group)->shared_data;

	dword o=mz_shared->header.header_size*16;
	ht_uviewer *v=new ht_uviewer(b, "mz/image", file, 0);
	hts_mask *m=new hts_mask(file, 0);
	char info[128];
	sprintf(info, "* MZ image at offset %08lx", o);
	m->add_mask(info);
	v->insertsub(m);
	hts_unasm *d=new hts_unasm(file, o, (mz_shared->header.sizep-1)*512+mz_shared->header.sizelp, 0);
	v->insertsub(d);
	return v;
}

viewer_int htmzimage_int = {
	htmzimage_detect,
	htmzimage_init
};
