/* 
 *	HT Editor
 *	htpeimp.h
 *
 *	Copyright (C) 1999,2000 Stefan Weyergraf (stefan@weyergraf.de)
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License version 2 as
 *	published by the Free Software Foundation.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __HTPEIMP_H__
#define __HTPEIMP_H__

#include "viewers.h"

extern viewer_int htpeimports_int;

/*
 *	class ht_pe_import_dlibrary
 */

class ht_pe_import_library: public ht_data {
public:
	char *name;

	ht_pe_import_library();
	ht_pe_import_library(char *name);
	~ht_pe_import_library();
};

/*
 *	class ht_pe_import_function
 */

class ht_pe_import_function: public ht_data {
public:
	int dll;
	int byname;
	union {
		int ordinal;
		struct {
			char *name;
			int hint;
		} name;
	};
	int function_address;

	ht_pe_import_function();
	ht_pe_import_function(int dll, int function_address, int ordinal);
	ht_pe_import_function(int dll, int function_address, char *name, int hint);
	~ht_pe_import_function();
};

struct ht_pe_import {
	ht_collection funcs;
	ht_collection libs;
};

/*
 *	CLASS ht_pe_import_viewer
 */

class ht_pe_import_viewer: public ht_uviewer {
public:
	ht_pe_import_viewer(bounds *b, char *desc, htstream *file, int caps);
	~ht_pe_import_viewer();
/* overwritten */
	char *func(int i, int getname);
	void ref(dword id);
};

/*
 *	CLASS hts_pe_import_mask
 */

class hts_pe_import_mask: public hts_mask {
protected:
	dword *sort_va;
	dword *sort_name;
	int sort;
	dword *sort_path;
public:
	hts_pe_import_mask(htstream *file, int start);
	virtual ~hts_pe_import_mask();
/* overwritten */
	virtual int getline(char *line, ADDR ofs, int yofs);
/* new */
		   void sortbyva();
		   void sortbyname();
		   void unsort();
};

#endif /* !__HTPEIMP_H__ */
