/* 
 *	HT Editor
 *	htsearch.h
 *
 *	Copyright (C) 1999,2000 Stefan Weyergraf (stefan@weyergraf.de)
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License version 2 as
 *	published by the Free Software Foundation.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __HTSEARCH_H__
#define __HTSEARCH_H__

#include "htdialog.h"
#include "htobj.h"
#include "htstream.h"

int search_str(htstream *file, dword start, dword end, dword pattern_len, byte *pattern, dword *result_ofs, ht_progress_indicator *progress_indicator, int caseinsensitive, int idle);

/*
 *	CLASS ht_hexascii_search_mask
 */

struct ht_hexascii_search_mask_data {
	byte *str;
	dword strlen;
	byte *start;
	dword startlen;
	byte *end;
	dword endlen;
	int caseinsensitive;
	int idle;
	char variable[0];
};

class ht_hexascii_search_mask: public ht_group {
protected:
	ht_strinputfield *str;
	ht_strinputfield *range_start;
	ht_strinputfield *range_end;
	ht_checkboxes *options;
public:
	ht_hexascii_search_mask(bounds *b);
	~ht_hexascii_search_mask();
/* overwritten */
	virtual int datasize();
	virtual void getdata(void *buf);
};

/*
 *	CLASS ht_casm_search_mask
 */

struct ht_casm_search_mask_data {
	byte *str;
	dword strlen;
	byte *start;
	dword startlen;
	byte *end;
	dword endlen;
	int caseinsensitive;
	int idle;
	char variable[0];
};

class ht_casm_search_mask: public ht_group {
protected:
	ht_strinputfield *str;
	ht_strinputfield *range_start;
	ht_strinputfield *range_end;
	ht_checkboxes *options;
public:
	ht_casm_search_mask(bounds *b);
	~ht_casm_search_mask();
/* overwritten */
	virtual int datasize();
	virtual void getdata(void *buf);
};

#endif /* __HTSEARCH_H__ */
