/* 
 *	HT Editor
 *	httag.h
 *
 *	Copyright (C) 1999,2000 Stefan Weyergraf (stefan@weyergraf.de)
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License version 2 as
 *	published by the Free Software Foundation.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __HTTAG_H__
#define __HTTAG_H__

#include "global.h"

#define HT_EDIT_BYTE 1
#define HT_EDIT_BYTE_CH "\e\1"
#define HT_EDIT_BYTE_LEN (2+8+2+2)
#define HT_EDIT_BYTE_VLEN (2)
#define HT_EDIT_BYTE_SIZE (1)

#define HT_EDIT_WORD 2
#define HT_EDIT_WORD_CH "\e\2"
#define HT_EDIT_WORD_LEN (2+8+4+2)
#define HT_EDIT_WORD_VLEN (4)
#define HT_EDIT_WORD_SIZE (2)

#define HT_EDIT_DWORD 3
#define HT_EDIT_DWORD_CH "\e\3"
#define HT_EDIT_DWORD_LEN (2+8+8+2)
#define HT_EDIT_DWORD_VLEN (8)
#define HT_EDIT_DWORD_SIZE (4)

#define HT_EDIT_TIME 4
#define HT_EDIT_TIME_CH "\e\4"
#define HT_EDIT_TIME_LEN (2+8+8+2)
#define HT_EDIT_TIME_VLEN (19)
#define HT_EDIT_TIME_SIZE (4)

#define HT_EDIT_CHAR 5
#define HT_EDIT_CHAR_CH "\e\5"
#define HT_EDIT_CHAR_LEN (2+8+2+2)
#define HT_EDIT_CHAR_VLEN (1)
#define HT_EDIT_CHAR_SIZE (1)

#define HT_SEL 6
#define HT_SEL_CH "\e\6"
#define HT_SEL_LEN(n) (2+8+2+2+8+n)
#define HT_SEL_VLEN(n) (n)
#define HT_SEL_SIZE (0)

#define HT_EXPL 7
#define HT_EXPL_CH "\e\7"
#define HT_EXPL_LEN (2+8)

#define HT_GROUP 8
#define HT_GROUP_CH "\e\x8"
#define HT_GROUP_LEN (2)

#define tag_coloridx_normal				0
#define tag_coloridx_normal_str			"00"

#define tag_coloridx_edit_selected			1
#define tag_coloridx_edit_selected_str		"01"
#define tag_coloridx_edit_unselected		2
#define tag_coloridx_edit_unselected_str	"02"
#define tag_coloridx_edit_edited			3
#define tag_coloridx_edit_edited_str		"03"
#define tag_coloridx_edit_modified			4
#define tag_coloridx_edit_modified_str		"04"

#define tag_coloridx_sel_selected			5
#define tag_coloridx_sel_selected_str		"05"
#define tag_coloridx_sel_unselected		6
#define tag_coloridx_sel_unselected_str		"06"

#define _CHAR(ofs) HT_EDIT_CHAR_CH ofs"00"tag_coloridx_edit_unselected_str
#define _BYTE(ofs) HT_EDIT_BYTE_CH ofs"00"tag_coloridx_edit_unselected_str
#define _WORD(ofs) HT_EDIT_WORD_CH ofs"0000"tag_coloridx_edit_unselected_str
#define _DWORD(ofs) HT_EDIT_DWORD_CH ofs"00000000"tag_coloridx_edit_unselected_str
#define _TIME(ofs) HT_EDIT_TIME_CH ofs"00000000"tag_coloridx_edit_unselected_str

#define _SEL(unique_id, len) HT_SEL_CH unique_id len tag_coloridx_sel_unselected_str"ffffffff"
#define _REF(unique_id, len, ref_id) HT_SEL_CH unique_id len tag_coloridx_sel_unselected_str ref_id

void tag_autotag(char *autotagstring, char *desc);

char *findtag(char *tagstring);
int tag_get_len(char *tagstring);
int tag_get_vlen(char *tagstring);
int tag_get_slen(char *tagstring);
int tag_get_size(char *tagstring);
dword tag_get_offset(char *tagstring);
int tag_get_value(char *tagstring);
void tag_set_color(char *tagstring, int color);
void tag_set_offset(char *tagstring, dword offset);
void tag_set_value(char *tagstring, int value);
int tag_is_editable(char *tagstring);
int tag_getselid(char *tagstring);

void tag_strcpy(char *dest, char *src);
char *tag_strdup(char *tagstring);
int tag_strlen(char *tagstring);

int count_editables_in_group(char *tagstring, int group);
int count_editables(char *tagstring);
int count_groups(char *tagstring);
char *get_editable(char *tagstring, int n, int group);
char *get_group(char *tagstring, int group);

char *mktag_edit_byte(char *buf, ADDR ofs, byte d, byte color);
char *mktag_edit_word(char *buf, ADDR ofs, word d, byte color);
char *mktag_edit_dword(char *buf, ADDR ofs, dword d, byte color);
char *mktag_edit_time(char *buf, ADDR ofs, dword d, byte color);
char *mktag_edit_char(char *buf, ADDR ofs, byte d, byte color);
char *mktag_group(char *buf);
char *mktag_sel(char *buf, dword unique_id, byte color, char *string);
char *mktag_ref(char *buf, dword unique_id, byte color, char *string, dword id);

#endif /* !__HTTAG_H__ */
